searchNodes=[{"doc":"Contains basic functions for similarity calculation. Similarity.Cosine - easy cosine similarity calculation Similarity.Simhash - simhash similarity calculation between two strings","ref":"Similarity.html","title":"Similarity","type":"module"},{"doc":"Calculates Cosine similarity between two vectors. https://en.wikipedia.org/wiki/Cosine_similarity#Definition Example: Similarity . cosine ( [ 1 , 2 , 3 ] , [ 1 , 2 , 8 ] )","ref":"Similarity.html#cosine/2","title":"Similarity.cosine/2","type":"function"},{"doc":"Multiplies cosine similarity with the square root of compared vectors length. srol here means square root of length This gives better comparable numbers where the number of attributes compared might differ. You can try to use this instead of cosine/2 if the number of shared attributes differ. Example: Similarity . cosine_srol ( [ 1 , 2 , 3 ] , [ 1 , 2 , 8 ] )","ref":"Similarity.html#cosine_srol/2","title":"Similarity.cosine_srol/2","type":"function"},{"doc":"Calculates Euclidean dot product of two vectors. https://en.wikipedia.org/wiki/Euclidean_vector#Dot_product Example: iex&gt; Similarity . dot_product ( [ 1 , 2 ] , [ 3 , 4 ] ) 11","ref":"Similarity.html#dot_product/3","title":"Similarity.dot_product/3","type":"function"},{"doc":"Calculates Euclidean magnitude of one vector. https://en.wikipedia.org/wiki/Magnitude_(mathematics)#Euclidean_vector_space Example: iex&gt; Similarity . magnitude ( [ 2 ] ) 2.0","ref":"Similarity.html#magnitude/2","title":"Similarity.magnitude/2","type":"function"},{"doc":"For docs see Similarity.Simhash","ref":"Similarity.html#simhash/3","title":"Similarity.simhash/3","type":"function"},{"doc":"For docs see Similarity.SorensenDice","ref":"Similarity.html#sorensen_dice/3","title":"Similarity.sorensen_dice/3","type":"function"},{"doc":"A struct that can be used to accumulate ids &amp; attributes and calcuate similarity between them.","ref":"Similarity.Cosine.html","title":"Similarity.Cosine","type":"module"},{"doc":"Puts a new id with attributes into %Cosine{}.map and returns %Cosine{} struct. Examples s = Similarity.Cosine . new s = s |&gt; Similarity.Cosine . add ( &quot;barna&quot; , [ { &quot;n_of_bacons&quot; , 3 } , { &quot;hair_color_r&quot; , 124 } , { &quot;hair_color_g&quot; , 188 } , { &quot;hair_color_b&quot; , 11 } ] )","ref":"Similarity.Cosine.html#add/3","title":"Similarity.Cosine.add/3","type":"function"},{"doc":"Returns Similarity.cosine_srol/2 similarity between two pairs of ids (id_a, id_b) in %Cosine{} Examples s = Similarity.Cosine . new s = s |&gt; Similarity.Cosine . add ( &quot;barna&quot; , [ { &quot;n_of_bacons&quot; , 3 } , { &quot;hair_color_r&quot; , 124 } , { &quot;hair_color_g&quot; , 188 } , { &quot;hair_color_b&quot; , 11 } ] ) s = s |&gt; Similarity.Cosine . add ( &quot;somebody&quot; , [ { &quot;n_of_bacons&quot; , 0 } , { &quot;hair_color_r&quot; , 222 } , { &quot;hair_color_g&quot; , 62 } , { &quot;hair_color_b&quot; , 11 } ] ) s |&gt; Similarity.Cosine . between ( &quot;barna&quot; , &quot;somebody&quot; )","ref":"Similarity.Cosine.html#between/3","title":"Similarity.Cosine.between/3","type":"function"},{"doc":"Returns a new %Cosine{} struct to be first used with add/3 function","ref":"Similarity.Cosine.html#new/0","title":"Similarity.Cosine.new/0","type":"function"},{"doc":"Returns a stream of all unique pairs of similarities in %Cosine{}.map Examples s = Similarity.Cosine . new s = s |&gt; Similarity.Cosine . add ( &quot;barna&quot; , [ { &quot;n_of_bacons&quot; , 3 } , { &quot;hair_color_r&quot; , 124 } , { &quot;hair_color_g&quot; , 188 } , { &quot;hair_color_b&quot; , 11 } ] ) s = s |&gt; Similarity.Cosine . add ( &quot;somebody&quot; , [ { &quot;n_of_bacons&quot; , 0 } , { &quot;hair_color_r&quot; , 222 } , { &quot;hair_color_g&quot; , 62 } , { &quot;hair_color_b&quot; , 11 } ] ) Similarity.Cosine . stream ( s )","ref":"Similarity.Cosine.html#stream/1","title":"Similarity.Cosine.stream/1","type":"function"},{"doc":"Simhash string similarity algorithm. Description of Simhash iex&gt; Similarity . simhash ( &quot;Barna&quot; , &quot;Kovacs&quot; ) 0.59375 iex&gt; Similarity . simhash ( &quot;Austria&quot; , &quot;Australia&quot; ) 0.65625","ref":"Similarity.Simhash.html","title":"Similarity.Simhash","type":"module"},{"doc":"Returns Hamming distance between the left and right hash, given as lists of bits. Examples iex&gt; Similarity.Simhash . hamming_distance ( [ 1 , 1 , 0 , 1 , 0 ] , [ 0 , 1 , 1 , 1 , 0 ] ) 2","ref":"Similarity.Simhash.html#hamming_distance/3","title":"Similarity.Simhash.hamming_distance/3","type":"function"},{"doc":"Returns the hash for the given string and hash_function in the given return_type . Options :ngram_size - defaults to 3 :hash_function - defaults to :siphash, available options are :siphash, :md5, :sha256 :return_type - defaults to :list, available options are :list, :int64_unsigned, :int64_signed, :binary The return types :int64_unsigned and :int64_signed are only available for the :siphash hash function. Examples Similarity.Simhash . hash ( &quot;alma korte&quot; ) [ 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 1 , 0 , 1 , ... ] iex&gt; Similarity.Simhash . hash ( &quot;alma korte&quot; , ngram_size : 3 , hash_function : :siphash , return_type : :int64_unsigned ) 15012197954348909067 iex&gt; Similarity.Simhash . hash ( &quot;alma korte&quot; , ngram_size : 3 , hash_function : :siphash , return_type : :int64_signed ) - 3434546119360642549","ref":"Similarity.Simhash.html#hash/2","title":"Similarity.Simhash.hash/2","type":"function"},{"doc":"","ref":"Similarity.Simhash.html#hash_similarity/3","title":"Similarity.Simhash.hash_similarity/3","type":"function"},{"doc":"Calculates the similarity between the left and right string, using Simhash. Returns a float representing similarity between left and right strings. Options :ngram_size - defaults to 3 Examples iex&gt; Similarity . simhash ( &quot;khan academy&quot; , &quot;khan academia&quot; ) 0.890625 iex&gt; Similarity . simhash ( &quot;khan academy&quot; , &quot;academy khan&quot; , ngram_size : 1 ) 1.0","ref":"Similarity.Simhash.html#similarity/3","title":"Similarity.Simhash.similarity/3","type":"function"},{"doc":"String similarity comparison with the Sorensen-Dice algorithm. Wikipedia","ref":"Similarity.SorensenDice.html","title":"Similarity.SorensenDice","type":"module"},{"doc":"Calculates the similarity between the left and right attributes, using Sorensen-Dice coefficient. Attribute can be a string, list or a MapSet. Examples iex&gt; Similarity.SorensenDice . sorensen_dice ( &quot;alma&quot; , &quot;korte&quot; ) 0.0 iex&gt; Similarity.SorensenDice . sorensen_dice ( &quot;alma&quot; , &quot;alma&quot; ) 1.0 iex&gt; Similarity.SorensenDice . sorensen_dice ( &quot;just letters&quot; , &quot;letters just&quot; , ngram_size : 1 ) 1.0 iex&gt; Similarity.SorensenDice . sorensen_dice ( &quot;this that&quot; , &quot;just that&quot; ) 0.42857142857142855 iex&gt; Similarity.SorensenDice . sorensen_dice ( [ 1 , 2 , 3 ] , [ 1 , 2 , 3 ] ) 1.0 iex&gt; Similarity.SorensenDice . sorensen_dice ( [ 1 , 2 , 3 ] , [ 1 , 2 , 3 , 4 ] ) 0.8571428571428571","ref":"Similarity.SorensenDice.html#sorensen_dice/3","title":"Similarity.SorensenDice.sorensen_dice/3","type":"function"}]